#!/usr/local/bin/perl
#v0.26b

use CGI qw(:standard);
use CGI::Carp ('fatalsToBrowser');
use CGI::Cookie;
use DBI;

#my $dbun = 'user';
#my $dbpw = 'pass';
#my $dsn = 'DBI:Sybase:server=sql-01.example.net;database=esec'; # MSSQL/Sybase
#my $dsn = 'DBI:mysql:host=sql-01.example.net;database=esec'; # MySQL

if(my $msgid=param('msgid')){
	my $dbh = DBI->connect($dsn, $dbun, $dbpw,{RaiseError => 1});
	my $sql = 'SELECT sender,emailid FROM messages WHERE msgid = ' . $dbh->quote($msgid);
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	my $row=$sth->fetchrow_hashref;
	$sth->finish;
	my $sender=$row->{sender};
	my $emailid=$row->{emailid};
	
	unless(defined($sender) && defined($emailid)){
		print header(), start_html(),
		      "Sorry, I have no Pending message matching your request.\n",
		      end_html();
		exit;
	}
	
	my $sql = 'SELECT email,name,mode FROM accounts WHERE emailid = ' . $dbh->quote($emailid);
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	my $row=$sth->fetchrow_hashref;
	$sth->finish;
	my $email = $row->{email};
	my $mode = $row->{mode};
	my $name = $row->{name};

	print header(), start_html();
	# loose or strict mode ?
	if($mode == 2){
		if((my $qid=param('qid')) && (my $response=param('response')) && param('Give Answer')){
			# check if answer is correct
			my $sql = 'SELECT answer FROM challenges WHERE qid = ' . $dbh->quote($qid);
			my $sth = $dbh->prepare($sql);
			$sth->execute;
			my $row=$sth->fetchrow_hashref;
			$sth->finish;
			my $answer = $row->{answer};
			if($answer =~ /^$response$/i){
				move_file($email,$sender,$emailid,$dbh);
				print "Thank you for confirming your email address.  You wont have to do this again unless<br>\n",
			      " your email address changes.  All messages you've sent me (that were in my Pending folder)<br>\n",
			      " have been delivered to my Inbox.\n",
			      "<br>\n",
				  "Thanks again,<br><br>\n",
				   "$name", end_html();
			}else{
				print "The answer you gave is not the same as what I have on record.. please try again.<br>\n",
				      "perhaps re-wording your answer will help<br>\n",
					  'click <a href="javascript:history.back(1)">here</a> to try again.', "<br>\n";
			}
		}else{
			my $sql = 'SELECT COUNT(*) FROM challenges';
			my $sth = $dbh->prepare($sql);
			$sth->execute;
			my $row=$sth->fetchrow_hashref;
			$sth->finish;
			my ($count) = values %$row; # mssql field = COL(1), mysql field = COUNT(*)

			my $qid = sprintf "%.F", (rand(($count-1)) + 1); # dont want it to come back with 0
			# if they didnt know the old question, dont give them the same one right away
			if((my $oldqid=param('qid')) && param('I Dont Know') && ($qid == $oldqid)){
				until($qid != $oldqid){
					$qid = sprintf "%.F", (rand(($count-1)) + 1); # dont want it to come back with 0
				}
			}
			
			my $sql = 'SELECT question FROM challenges WHERE qid = ' . $dbh->quote($qid);
			my $sth = $dbh->prepare($sql);
			$sth->execute;
			my $row=$sth->fetchrow_hashref;
			$sth->finish;
			my $question = $row->{question};

			print "To verify you are a not an evil spammer, please answer the following question:<br>\n",
			      "${question}<br>\n",
			      start_form('post','/cgi-bin/eseccgi.pl'), "\n",
				  hidden('qid',$qid), hidden('msgid',$msgid), "\n",
			      '<input type="text" name="response" maxlength="255">', "\n",
			      submit('Give Answer'), submit('I Dont Know'), end_form();
		}
		exit;
	}else{
		move_file($email,$sender,$emailid,$dbh);
		print "Thank you for confirming your email address.  You wont have to do this again unless<br>\n",
		      " your email address changes.  All messages you've sent me (that were in my Pending folder)<br>\n",
		      " have been delivered to my Inbox.\n",
		      "<br>\n",
			  "Thanks again,<br><br>\n",
			   "$name", end_html();
		exit;
	}
}else{
	# management console
	my %cookies = fetch CGI::Cookie;
	if( ($cookies{'sess_id'} =~ /sess_id=(.+)\;/) && (my $sess_id = $1) ){
		my $dbh = DBI->connect($dsn, $dbun, $dbpw,{RaiseError => 1});
		my $sql = 'SELECT emailid,email,name FROM accounts WHERE session_id = ' . $dbh->quote($sess_id);
		my $sth = $dbh->prepare($sql);
		$sth->execute;
		my $row=$sth->fetchrow_hashref;
		$sth->finish;
		if((my $emailid = $row->{emailid}) && (my $name = $row->{name}) && (my $email = $row->{email})){
			print header(), start_html('ESec Management Console'),
			      "<center><h2>ESec Management Console</h2></center>\n",
			      '<a href="eseccgi.pl">Home</a><br>', "\n",
			      '<a href="eseccgi.pl?showpnd=1">View Pending Messages</a><br>', "\n",
			      '<a href="eseccgi.pl?modify=message">Modify Your Confirmation Message</a><br><br>', "\n";
			if((my $file=param('filename')) && (my $submit=param('Submit'))){
				if(($submit eq 'Whitelist') && (my $sender=param('sender'))){
					my $sql = 'INSERT INTO email_whitelists (addr,emailid) VALUES (';
					$sql .= $dbh->quote($sender) . ',' . $dbh->quote($emailid) . ')';
					my $sth = $dbh->prepare($sql);
					$sth->execute || warn "cannot insert whitelist into db: $!\n";
			
					print "${sender} added to email whitelist<br>\n";
				}else{
					my $maildir = get_maildir($email); # guaranteed
				
					my $sql = 'DELETE FROM messages WHERE emailid = ' . $dbh->quote($emailid);
					$sql .= ' AND filename = ' . $dbh->quote($file);
					my $sth = $dbh->prepare($sql);
					$sth->execute || warn "cannot remove $file from db: $!\n";
					if($submit eq 'Delete'){
						if(unlink("${maildir}/pnd/${file}")){
							print '<meta http-equiv="refresh" content="0; url=eseccgi.pl?showpnd=1">';
							exit;
						}else{
							print "could not unlink $file: $!\n";
						}
					}elsif($submit eq 'Move'){
						if(rename("${maildir}/pnd/${file}","${maildir}/new/${file}")){
							print "Message is now ready to be transferred.<br>\n";
						}else{
							print "couldnt rename file: $!\n";
						}
					}else{
						die "submit is $submit (expected Delete or Move)\n";
					}
				}
				print 'click <a href="eseccgi.pl?showpnd=1">here</a> to continue.<br>';
			}elsif((param('Submit') eq 'Delete All') && (param('confirm') eq "Im sure")){
				my $maildir = get_maildir($email);

				# one at a time, for consitency (think new incoming messages)
				my $sql = 'SELECT filename FROM messages WHERE emailid = ' . $dbh->quote($emailid);
				my $sth = $dbh->prepare($sql);
				$sth->execute;
				while(my $row=$sth->fetchrow_hashref){
					my $file = $row->{filename};
					if(unlink("${maildir}/pnd/${file}")){
						my $sqla = 'DELETE FROM messages WHERE emailid = ' . $dbh->quote($emailid);
						$sqla .= ' AND filename = ' . $dbh->quote($file);
						my $stha = $dbh->prepare($sqla);
						$stha->execute || warn "could not delete $file from db: $!\n";
					}else{
						warn "could not delete $file: $!\n";
					}
				}
				print '<meta http-equiv="refresh" content="0; url=eseccgi.pl?showpnd=1">';
				exit;
			}elsif(my $sort=param('showpnd')){
				my $pnddir = get_maildir($email) . "/pnd";

				if(my $file=param('pndfile')){
					die if(($file !~ /^\d+\.\d+\.esec\./) || ($file =~ /\.\./) || ($file =~ /[^a-z\d\.\-]/i));
					
					if(open(F, "${pnddir}/${file}")){
						print "<pre>\n";
						while(<F>){
							s/>/\&gt;/g;
							s/</\&lt;/g;
							print;
						}
						close F;
						print "</pre>\n";
					}else{
						print "sorry, I cant find that message; perhaps it was just confirmed..\n";
					}
				}else{
					print "Pending Messages:<br>\n",
					      '<table border="1"><tr>',
					      ' <td><b><a href="eseccgi.pl?showpnd=from';
					if($sort eq 'from'){
						print '&reverse=1' unless(param('reverse'));
						$f = '&nbsp;*';
					}
					print '">From</a></b>', "${f}</td>\n",
						  ' <td><b><a href="eseccgi.pl?showpnd=subject';
					if($sort eq 'subject'){
						print '&reverse=1' unless(param('reverse'));
						$s = '&nbsp;*';
					}	
					print '">Subject</a></b>', "${s}</td>\n",
					      ' <td><b><a href="eseccgi.pl?showpnd=received';
					if($sort eq 'received'){
						print '&reverse=1' unless(param('reverse'));
						$r = '&nbsp;*';
					}
					print '">Received</b></a>', "${r}</td>\n",
					      " <td><b>Whitelist User</b></td>\n",
						  " <td><b>Move to Inbox</b></td>\n",
						  " <td><b>Delete</b></td>\n",
						  "</tr>\n";
					opendir(D, "$pnddir") || die "cannot opendir $pnddir: $!\n";
					#my(%from,%subject,%received,%html);
					foreach my $file (grep {!/^\./} readdir D){
						my %msg;

						open(F, "${pnddir}/${file}") || die "cannot open file $pnddir/$file: $!\n";
						while(<F>){
							last if((/^$/) ||
								(exists($msg{'received'}) && exists($msg{'from'}) && exists($msg{'subject'})));
							if(/^X-ESec-Received:\s(.+)/){
								$msg{'received'} = $1;
							}elsif(/^Return-Path:\s\<(.{0,27})(.*)\>/i){ # we whitelist/blacklist based on envelope
								$msg{'from'} = $1;
								if(length($2) > 3){
									$msg{'from'} .= '...';
								}elsif($2){
									$msg{'from'} .= $2;
								}
							}elsif(/^subject\s*:\s(.{0,27})(.*)/i){
								$msg{'subject'} = $1;
								if(length($2) > 3){
									$msg{'subject'} .= '...';
								}elsif($2){
									$msg{'subject'} .= $2;
								}
							}
						}
						close F;
						while(my $key = each %msg){
							$msg{$key} =~ s/>/\&gt;/g;
							$msg{$key} =~ s/</\&lt;/g;
						}
						my $link = 'eseccgi.pl?showpnd=1&pndfile=' . ${file};
						if($sort == 1){
							print start_form(), "<tr>\n",
						   	   " <td><a href=\"$link\">$msg{'from'}</a></td>\n",
						   	   " <td><a href=\"$link\">$msg{'subject'}</a></td>\n",
						   	   " <td>$msg{'received'}</td>\n",
						   	   " <td><center>", hidden('filename',${file}),
							   hidden('sender',$msg{'from'}),
							   submit('Submit','Whitelist'), "</center></td>\n<td><center>\n",
						   	   submit('Submit','Move'), "</center></td>\n",
							   " <td><center>", submit('Submit','Delete'), "</center></td>\n",
						   	   "</tr>\n", end_form(), "\n";
						}else{
							$data{from}{$file} = $msg{'from'};
							$data{subject}{$file} = $msg{'subject'};
							$data{received}{$file} = $msg{'received'};
							$data{html}{$file} = start_form() . "<tr>\n" .
						   	   " <td><a href=\"$link\">$msg{'from'}</a></td>\n" .
						   	   " <td><a href=\"$link\">$msg{'subject'}</a></td>\n" .
						   	   " <td>$msg{'received'}</td>\n" .
						   	   " <td><center>" . hidden('filename',${file}) .
						   	   submit('Submit','Move') . "</center></td>\n" .
							   " <td><center>" . submit('Submit','Delete') . "</center></td>\n" .
						   	   "</tr>\n" . end_form() . "\n";
								
						}
					}
					closedir D;
					unless($sort == 1){
						my @sorted;
						if(param('reverse')){
							@sorted = map { $_->[1] }                # un-transform
							 sort { lc($b->[0]) cmp lc($a->[0])      # sort
							     || lc($b->[0]) <=> lc($a->[0]) }    # sort (cont)
							 map { [ $data{$sort}{$_}, $_ ] }        # Schw. trans.
							 keys %{$data{$sort}};                   # yank out sort field
						}else{
							@sorted = map { $_->[1] }
							 sort { lc($a->[0]) cmp lc($b->[0])
							     || lc($a->[0]) <=> lc($b->[0]) }
							 map { [ $data{$sort}{$_}, $_ ] }
							 keys %{$data{$sort}};
						}
						foreach my $file (@sorted){
							print "$data{html}{$file}";
						}
					}
					print "</table>\n",
					      start_form('post','/cgi-bin/eseccgi.pl'), submit('Submit','Delete All'), "\n",
					      popup_menu(-name=>'confirm',
					                 -values=>['Im sure',''],
						             -default=>''), "\n",
					      end_form(), "\n";
				}
			}elsif(my $modify=param('modify')){
				my $link = "/cgi-bin/eseccgi.pl?modify=$modify";
				if($modify eq "message"){
					if(param('Submit') eq 'Delete'){
						my $sql = 'UPDATE accounts SET message = NULL WHERE emailid = ' . $dbh->quote($emailid);
						my $sth = $dbh->prepare($sql);
						$sth->execute || die "cannot update accounts: $!\n";

						print '<meta http-equiv="refresh" content="0; url=/cgi-bin/eseccgi.pl?modify=message">';
					}elsif((param('Submit') eq 'Save') && (my $message=param('message'))){
						my $sql = 'UPDATE accounts SET message = ' . $dbh->quote($message);
						$sql .= ' WHERE emailid = ' . $dbh->quote($emailid);
						my $sth = $dbh->prepare($sql);
						$sth->execute || die "cannot update accounts: $!\n";

						print '<meta http-equiv="refresh" content="0; url=/cgi-bin/eseccgi.pl?modify=message">';
					}else{
						my $sql = 'SELECT message FROM accounts WHERE emailid = ' . $dbh->quote($emailid);
						my $sth = $dbh->prepare($sql);
						$sth->execute;
						my $row = $sth->fetchrow_hashref;
						$sth->finish;
						my $message = $row->{message};

						print start_form(), "Your custom probe message: <br><br>\n",
						      '<textarea name="message" rows="10" cols="50">', ${message}, "</textarea>\n",
						      hidden('modify','message'), "<br><br>\n",
						      submit('Submit','Save'), "&nbsp;", submit('Submit','Delete'), end_form(), "<br>\n",
							  "<hr>\n<br>\n",
							  "Key:<br>\n",
						      "<i>%%name%%</i> will be replaced with your real name<br>\n",
					          "<i>%%msgid%%</i> will be replaced with the message id<br>\n",
						      "<i>%%subject%%</i> will be replaced with the subject of the original message<br>\n";
					}
				}elsif($modify eq "email_whitelist"){
					if(my @addrs = split(/\n/, param('new_whitelist'))){
						foreach my $new (@addrs){
							my $sql = 'SELECT COUNT(*) FROM email_whitelists WHERE addr = ' . $dbh->quote($new);
							$sql .= ' AND emailid = ' . $dbh->quote($emailid);
							my $sth = $dbh->prepare($sql);
							$sth->execute;
							my $row = $sth->fetchrow_hashref;
							my ($count) = values %$row;
							if($count == 0){
								my $sql = 'INSERT INTO email_whitelists (emailid,addr) VALUES (';
								$sql .= $dbh->quote($emailid) . ',' . $dbh->quote($new) . ')';
								my $sth = $dbh->prepare($sql);
								$sth->execute || warn "couldnt add $new to database: $!\n";
								print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
							}else{
								print "It appears <i>$new</i> is already in your whitelist.<br>\n";
								$dupe=1;
							}
						}
						if(defined($dupe)){
							print 'click <a href="', "$link", '">here</a> to continue.', "<br>\n";
						}
					}elsif((my $delete=param('addr')) && param('Delete')){
						my $sql = 'DELETE FROM email_whitelists WHERE emailid = ' . $dbh->quote($emailid);
						$sql .= ' AND addr = ' . $dbh->quote($delete);
						my $sth = $dbh->prepare($sql);
						$sth->execute;

						print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
					}else{
						print "modifing email whitelist<br>\n",
						      start_form(), hidden('modify',$modify),
						      'New Email Address(es) to Whitelist: ',
						      '<textarea name="new_whitelist" cols="30"></textarea><br>',
						      submit('Create'), end_form(), "\n",
						      '<table border="1">', "\n";
						my $sql = "SELECT addr FROM email_whitelists WHERE emailid = " . $dbh->quote($emailid);
						$sql .= " ORDER BY addr";
						my $sth = $dbh->prepare($sql);
						$sth->execute;
						while(my $row=$sth->fetchrow_hashref){
								$addr=lc($row->{addr});
								print start_form(), "<tr><td>", hidden('addr',$addr), hidden('modify',$modify),
								      hidden('Delete','Delete'),
								      "$addr</td><td>", submit('Delete'), "</tr>", end_form(), "\n";
						}
						print "</table><br>\n",
					 		  '<a href="/cgi-bin/eseccgi.pl">Back To Main Menu</a>';
					}
				}elsif($modify eq "email_blacklist"){
					if(my $new=param('new_blacklist')){
						my $sql = 'SELECT COUNT(*) FROM email_blacklists WHERE addr = ' . $dbh->quote($new);
						$sql .= ' AND emailid = ' . $dbh->quote($emailid);
						my $sth = $dbh->prepare($sql);
						$sth->execute;
						my $row = $sth->fetchrow_hashref;
						my ($count) = values %$row;
						if($count == 0){
							my $sql = 'INSERT INTO email_blacklists (emailid,addr) VALUES (';
							$sql .= $dbh->quote($emailid) . ',' . $dbh->quote($new) . ')';
							my $sth = $dbh->prepare($sql);
							$sth->execute;

							print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
						}else{
							print "It appears <i>$new</i> is already in your blacklist.<br>\n",
							      'click <a href="', "$link", '">here</a> to continue.', "<br>\n";

						}
					}elsif((my $delete=param('addr')) && param('Delete')){
						my $sql = 'DELETE FROM email_blacklists WHERE emailid = ' . $dbh->quote($emailid);
						$sql .= ' AND addr = ' . $dbh->quote($delete);
						my $sth = $dbh->prepare($sql);
						$sth->execute;

						print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
					}else{
						print "modifing email blacklist<br>\n",
						      start_form(), hidden('modify',$modify),
						      'New Email Address to Blacklist: <input type="text" name="new_blacklist"><br>',
						      submit('Create'), end_form(), "\n",
						      '<table border="1">', "\n";
						my $sql = "SELECT addr FROM email_blacklists WHERE emailid = " . $dbh->quote($emailid);
						$sql .= " ORDER BY addr";
						my $sth = $dbh->prepare($sql);
						$sth->execute;
						while(my $row=$sth->fetchrow_hashref){
							$addr=lc($row->{addr});
							print start_form(), "<tr><td>", hidden('addr',$addr), hidden('modify',$modify),
							      hidden('Delete','Delete'),
							      "$addr</td><td>", submit('Delete'), "</tr>", end_form(), "\n";
						}
						print "</table><br>\n",
					 		  '<a href="/cgi-bin/eseccgi.pl">Back To Main Menu</a>';
					}
				}elsif($modify eq "header_whitelist"){
					if(my @newfields = split(/\n/, param('new_whitelist'))){
						foreach my $new (@newfields){
							my $sql = 'SELECT COUNT(*) FROM header_whitelists WHERE field = ' . $dbh->quote($new);
							$sql .= ' AND emailid = ' . $dbh->quote($emailid);
							my $sth = $dbh->prepare($sql);
							$sth->execute;
							my $row = $sth->fetchrow_hashref;
							my ($count) = values %$row;
							if($count == 0){
								my $sql = 'INSERT INTO header_whitelists (emailid,field) VALUES (';
								$sql .= $dbh->quote($emailid) . ',' . $dbh->quote($new) . ')';
								my $sth = $dbh->prepare($sql);
								$sth->execute;
								print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
							}else{
								print "It appears <i>$new</i> is already in your whitelist.<br>\n";
								$dupe=1;
							}
						}
						if(defined($dupe)){
							print 'click <a href="', "$link", '">here</a> to continue.', "<br>\n";
						}
					}elsif((my $delete=param('header')) && param('Delete')){
						my $sql = 'DELETE FROM header_whitelists WHERE emailid = ' . $dbh->quote($emailid);
						$sql .= ' AND field = ' . $dbh->quote($delete);
						my $sth = $dbh->prepare($sql);
						$sth->execute;

						print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
					}else{
						print "modifing header whitelist<br>\n",
						      start_form(), hidden('modify',$modify),
						      'New Header Field(s) to Whitelist: ',
						      '<textarea name="new_whitelist" cols="50"></textarea><br>',
						      submit('Create'), end_form(), "\n",
						      '<table border="1">', "\n";
						my $sql = "SELECT field FROM header_whitelists WHERE emailid = " . $dbh->quote($emailid);
						$sql .= " ORDER BY field";
						my $sth = $dbh->prepare($sql);
						$sth->execute;
						while(my $row=$sth->fetchrow_hashref){
								$field=$row->{field};
								$field =~ s/</&lt;/g;
								$field =~ s/>/&gt;/g;
								$field =~ s/"/&quot;/g;
								print start_form(), "<tr><td>", hidden('header',$field), hidden('modify',$modify),
								      hidden('Delete','Delete'),
								      "$field</td><td>", submit('Delete'), "</tr>", end_form(), "\n";
						}
						print "</table><br>\n",
					 		  '<a href="/cgi-bin/eseccgi.pl">Back To Main Menu</a>';
					}
				}elsif($modify eq "header_blacklist"){
					if(my @fields = split(/\n/, param('new_blacklist'))){
						foreach my $new (@fields){
							my $sql = 'SELECT COUNT(*) FROM header_blacklists WHERE field = ' . $dbh->quote($new);
							$sql .= ' AND emailid = ' . $dbh->quote($emailid);
							my $sth = $dbh->prepare($sql);
							$sth->execute;
							my $row = $sth->fetchrow_hashref;
							my ($count) = values %$row;
							if($count == 0){
								my $sql = 'INSERT INTO header_blacklists (emailid,field) VALUES (';
								$sql .= $dbh->quote($emailid) . ',' . $dbh->quote($new) . ')';
								my $sth = $dbh->prepare($sql);
								$sth->execute;
	
								print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
							}else{
								print "It appears <i>$new</i> is already in your blacklist.<br>\n";
							}
						}
						if(defined($dupe)){
							print 'click <a href="', "$link", '">here</a> to continue.', "<br>\n";
						}
					}elsif((my $delete=param('field')) && param('Delete')){
						my $sql = 'DELETE FROM header_blacklists WHERE emailid = ' . $dbh->quote($emailid);
						$sql .= ' AND field = ' . $dbh->quote($delete);
						my $sth = $dbh->prepare($sql);
						$sth->execute;

						print '<meta http-equiv="refresh" content="0; url=', "$link", '">', end_html();
					}else{
						print "modifing header blacklist<br>\n",
						      start_form(), hidden('modify',$modify),
						      'New Field(s) to Blacklist: ',
						      '<textarea name="new_blacklist" cols="50"></textarea><br>',
						      submit('Create'), end_form(), "\n",
						      '<table border="1">', "\n";
						my $sql = "SELECT field FROM header_blacklists WHERE emailid = " . $dbh->quote($emailid);
						$sql .= " ORDER BY field";
						my $sth = $dbh->prepare($sql);
						$sth->execute;
						while(my $row=$sth->fetchrow_hashref){
								$field = $row->{field};
								$field =~ s/</\&lt;/g;
								$field =~ s/>/\&gt;/g;
								$field =~ s/&/\&amp;/g;
								print start_form(), "<tr><td>", hidden('field',$field), hidden('modify',$modify),
								      hidden('Delete','Delete'),
								      "$field</td><td>", submit('Delete'), "</tr>", end_form(), "\n";
						}
						print "</table><br>\n",
					 		  '<a href="/cgi-bin/eseccgi.pl">Back To Main Menu</a>';
					}
				}else{
					print '<meta http-equiv="refresh" content="0; url=/cgi-bin/eseccgi.pl">';
				}
				print end_html();
			}else{
				my $unique = 0;
				my $sql = 'SELECT COUNT(*) FROM messages WHERE emailid = ' . $dbh->quote($emailid);
				my $sth = $dbh->prepare($sql);
				$sth->execute;
				my $row = $sth->fetchrow_hashref;
				my ($messages) = values %$row;
				if($messages > 0){
					my %senders;
					my $sql = 'SELECT sender FROM messages WHERE emailid = ' . $dbh->quote($emailid);
					my $sth = $dbh->prepare($sql);
					$sth->execute;
					while(my $row=$sth->fetchrow_hashref){
						$senders{lc($row->{sender})} = 1;
					}
					while(my $key = each %senders){
						$unique++;
					}
				}
				print "You have ${messages} messages in your pending queue by ${unique} unique senders.<br><br>\n",
				      '<table border="0" width="100%"><tr>', "\n",
				      '<td width="50%"><center><b>Email Whitelists</b>&nbsp;[',
				       '<a href="/cgi-bin/eseccgi.pl?modify=email_whitelist">Edit</a>]</center></td>',
				      '<td width="50%"><center><b>Email Blacklists</b>&nbsp;[',
				       '<a href="/cgi-bin/eseccgi.pl?modify=email_blacklist">Edit</a>]</center></td>', "\n",
				      "</tr><tr>\n";	
				foreach my $list ('white','black'){
					print '<td><textarea rows="10" cols="50" readonly>', "\n";
					my $sql = "SELECT addr FROM email_${list}lists WHERE emailid = " . $dbh->quote($emailid);
					$sql .= " ORDER BY addr";
					my $sth = $dbh->prepare($sql);
					$sth->execute;
					while(my $row=$sth->fetchrow_hashref){
							$addr=lc($row->{addr});
							print "${addr}\n";
					}
					print "</textarea></td>\n";
				}
				print "</tr>\n",
				      "<tr><td>&nbsp;</td><td>&nbsp;</td></tr>\n",
				      "<tr>\n",
				      '<td><center><b>Header Field Whitelists</b>&nbsp;[',
				       '<a href="/cgi-bin/eseccgi.pl?modify=header_whitelist">Edit</a>]</center></td>', "\n",
				      '<td><center><b>Header Blacklists</b>&nbsp;[',
				       '<a href="/cgi-bin/eseccgi.pl?modify=header_blacklist">Edit</a>]</center></td>', "\n",
				      '<tr><td><textarea rows="10" cols="50" readonly>', "\n";
				my $sql = 'SELECT field FROM header_whitelists WHERE emailid = ' . $dbh->quote($emailid);
				$sql .= " ORDER BY field";
				my $sth = $dbh->prepare($sql);
				$sth->execute;
				while(my $row=$sth->fetchrow_hashref){
					print "$row->{field}\n";
				}
				print '</textarea></td><td><textarea rows="10" cols="50" readonly>', "\n";
				my $sql = 'SELECT field FROM header_blacklists WHERE emailid = ' . $dbh->quote($emailid);
				$sql .= " ORDER BY field";
				my $sth = $dbh->prepare($sql);
				$sth->execute;
				while(my $row=$sth->fetchrow_hashref){
					print "$row->{field}\n";
				}
				print "</textarea></td></tr>\n",
				      "</table>\n",
				      end_html();
			}
		}elsif((my $email=param('email')) && (my $password=param('password'))){
			# authenticate - user wants to manage thier stuff
			
			my $sql = 'SELECT crypt FROM accounts WHERE email = ' . $dbh->quote($email);
			my $sth = $dbh->prepare($sql);
			$sth->execute;
			my $row=$sth->fetchrow_hashref;
			$sth->finish;
			my $crypt=$row->{crypt};
	
			print header(), start_html();
			if( ($crypt eq crypt($password, $crypt)) && defined($crypt) && defined($password) ){
				#authentcated -- save session_id and redirect back
		
				my $sql = 'UPDATE accounts SET session_id = ' . $dbh->quote($sess_id);
				$sql .= ' WHERE email = ' . $dbh->quote($email);
				my $sth = $dbh->prepare($sql);
				$sth->execute || die "cannot set session id to $sess_id for email $email: $!\n"; 
	
				print '<meta http-equiv="refresh" content="0">';
			}else{
				print "Authentication error.<br>\n",
				      'Click <a href="javascript:history.back(1)">here</a> to try again.<br>';
			}
			print end_html();
		}else{
			my $cookiesid = new CGI::Cookie(-name=>'sess_id',-value=>'');
			print header(-cookie=>[$cookiesid]), start_html(),
			      '<meta http-equiv="refresh" content="0">', end_html();
			exit;
		}
		$dbh->disconnect();
	}else{
		my $random = getrand(64); # 512bit
		my $cookiesid = new CGI::Cookie(-name=>'sess_id',-value=>"$random");
		print header(-cookie=>[$cookiesid]), start_html(), start_form(),
		      "<table>\n",
		      '<tr><td>Email Address: </td><td><input type="text" name="email"></td></tr>', "\n",
		      '<tr><td>Password: </td><td><input type="password" name="password"></td></tr>', "</table><br>\n",
		      submit('Login'), end_form(), end_html();
	}
}

sub getrand {
	my $len = shift || 32;
	my($buf,$x,$random);
	open(D, "/dev/urandom") || die "cannot open urandom: $!\n";
	my @set = ('A'..'Z', 'a'..'z', '0'..'9', '_', '.');
	foreach(1..$len){
		sysread( D, $buf, 1 );
		my $v = ord($buf);
		$x ^= ($v & ~63) >> (rand(7)+1);
		$random .= $set[ ($x ^ ord($buf)) & 63 ];
	}
	close D;

	return($random);
}

sub get_maildir {
	my $email = shift || die "get_maildir syntax error\n";
	my ($dir,$maildir);
	my($user,$domain) = split(/\@/, $email); # we dont support routing data
	open(A, "/var/qmail/users/assign") || die "cannot open assign: $!\n";
	while(<A>){
		if(/^\+$domain\-:[^:]+:\d+:\d+:([^:]+):/){
			$dir = $1;
			last;
		}
	}
	close A;
	
	open(V, "$dir/vpasswd") || die "cannot open $dir/vpasswd: $!\n";
	while(<V>){
		if(/^$user:[^:]+:\d+:\d+:[^:]*:([^:]+):/){
			$maildir = $1 . "/Maildir";
			last;
		}
	}
	close V;

	die "cannot find maildir for $email\n" unless(defined($maildir));
	return($maildir);
}

sub move_file {
	my $email = shift || die "move_mail syntax error: email\n";
	my $sender = shift || die "move_mail syntax error: sender\n";
	my $emailid = shift || die "move_mail syntax error: emailid\n";
	my $dbh = shift || die "move_mail syntax error: dbh\n";

	die "emailid doesnt look right: $emailid\n" unless($emailid =~ /^\d+$/);

	my $maildir = get_maildir($email);

	my $sql = 'SELECT filename FROM messages WHERE sender = ' . $dbh->quote($sender);
	$sql .= ' AND emailid = ' . $dbh->quote($emailid); # authenticate all msgs from sender to this emailid
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	my $file;
	while(my $row=$sth->fetchrow_hashref){
		$file = $row->{filename};
		my $sqla = 'DELETE FROM messages WHERE filename = ' . $dbh->quote($file);
		$sqla .= ' AND sender = ' . $dbh->quote($sender);
		my $stha = $dbh->prepare($sqla);

		$stha->execute || die "sql error: $!\n";
		rename("${maildir}/pnd/${file}","${maildir}/new/${file}") || die "cannot rename ${file}: $!\n";
	}
	
	unless(defined($file)){
		print header(), start_html(),
		      "It doesnt appear I have any messages from you in my Pending folder.<br>\n",
		      "Either they have already been delivered to my Inbox, have expired, or<br>\n",
		      "I simply havent heard from you before.<br>\n",
		      end_html();
		exit;
	}

	my $sql = 'INSERT INTO email_whitelists (addr,emailid) VALUES (' . $dbh->quote($sender);
	$sql .= ',' . $dbh->quote($emailid) . ')';
	my $sth = $dbh->prepare($sql);
	$sth->execute || die "cannot save results: $!\n";

	$dbh->disconnect();
}
