#!/usr/local/bin/perl
#0.24b

use strict;
use DBI;

my $dbun = 'username';
my $dbpw = 'password';
#my $dsn = 'DBI:Sybase:server=sql-01.example.com;database=esec'; # for MSSQL
#my $dsn = 'DBI:mysql:host=sql-01.example.com;database=esec'; # for MySQL

my (%pnddir);
#clean up database and remove pending messages older than 1 week, 1 day
# (over 1 week because qmail bounces after ~7days, we want bounces from that
# to remove the message from the queue, rather than send us the double bounce)

my $dbh = DBI->connect($dsn, $dbun, $dbpw,{RaiseError => 1});
my $sql = "SELECT filename,emailid FROM messages WHERE time < ($^T - 691200)";
my $sth = $dbh->prepare($sql);
$sth->execute;
while(my $row=$sth->fetchrow_hashref){
	my $filename=$row->{filename};
	my $emailid=$row->{emailid};
		
	unless(exists($pnddir{$emailid})){
		my $sql1 = 'SELECT email FROM accounts WHERE emailid = ' . $dbh->quote($emailid);
		my $sth1 = $dbh->prepare($sql1);
		$sth1->execute;
		my $row1 = $sth1->fetchrow_hashref;
		my ($user,$domain) = split(/\@/, $row1->{email});
	
		my($dir);
		open(A, '/var/qmail/users/assign') || die "cannot open assign: $!\n";
		while(<A>){
			if(/^\+${domain}\-:[^:]+:\d+:\d+:([^:]+):/){
				$dir = $1;
				last;
			}
		}
		close A;
	
		open(V, "${dir}/vpasswd") || die "cannot open $dir/vpasswd: $!\n";
		while(<V>){
			if(/^${user}:[^:]+:\d+:\d+:[^:]*:([^:]+):/){
				$pnddir{$emailid} = "$1/Maildir/pnd";
				last;
			}
		}
		close V;
	}

	if(unlink("$pnddir{$emailid}/${filename}")){
		my $sql = 'DELETE FROM messages WHERE filename = ' . $dbh->quote($filename);
		$sql .= ' AND emailid = ' . $dbh->quote($emailid);
		my $sth = $dbh->prepare($sql);
		$sth->execute || warn "cannot remove $filename from db: $!\n";
	}else{
 		warn "could not unlink $pnddir{$emailid}/${filename}: $!\n";
	}
}

# expire known bouncing users after 24 hours
my $sql = "DELETE FROM known_bouncers WHERE time < ($^T - 86400)";
my $sth = $dbh->prepare($sql);
$sth->execute || die "cannot delete from known_bouncers: $!\n";
